local M = {}

local lightsPDState = 0
--local ToggledPD = false
--local ToggledAlley = false
--local PDlights = 0
local blinkPDTimerThreshold = 1
local blinkPDTimerThresholdHalf = 0
local blinkPDTimer = 0
local blinkPDPulseLeft = 0
local blinkPDPulseRight = 0

local function onInit()
    electrics.values['RPM_led1'] = 0
    electrics.values['RPM_led2'] = 0
    electrics.values['RPM_led3'] = 0
    electrics.values['RPM_led4'] = 0
    electrics.values['RPM_led5'] = 0
    electrics.values['RPM_led6'] = 0
    electrics.values['RPM_led7'] = 0
    electrics.values['RPM_led8'] = 0
    electrics.values['RPM_led9'] = 0
    electrics.values['RPM_led10'] = 0
    electrics.values['RPM_led11'] = 0
    electrics.values['RPM_led12'] = 0
    electrics.values['RPM_led13'] = 0
    electrics.values['RPM_led14'] = 0
    electrics.values['RPM_led15'] = 0
    electrics.values['RPM_ledoff'] = 0
	electrics.values['led_off1'] = 0
	electrics.values['led_off2'] = 0
	electrics.values['light'] = 0
	electrics.values['light1'] = 0
end

local function onReset()
    onInit()
end


local function generateBlinkPDTimer(dt)

    blinkPDTimerThresholdHalf = (blinkPDTimerThreshold / 2)

    blinkPDTimer = blinkPDTimer + (dt)

    if blinkPDTimer > blinkPDTimerThreshold then
        blinkPDTimer = blinkPDTimer - blinkPDTimerThreshold
	blinkPDPulseLeft = 0
	blinkPDPulseRight = 1
	else
    if blinkPDTimer > blinkPDTimerThresholdHalf then
	blinkPDPulseLeft = 1
	blinkPDPulseRight = 0
	end
    end
end

local function updateGFX(dt)

    if electrics.values['rpm'] > 17100 and electrics.values['rpm'] < 19000 then
       electrics.values['RPM_led1'] = 1 else electrics.values['RPM_led1'] = 0
    end
	
    if electrics.values['rpm'] > 17200 and electrics.values['rpm'] < 19000 then
       electrics.values['RPM_led2'] = 1 else electrics.values['RPM_led2'] = 0
    end
	
    if electrics.values['rpm'] > 17300 and electrics.values['rpm'] < 19000 then
       electrics.values['RPM_led3'] = 1 else electrics.values['RPM_led3'] = 0
    end
	
    if electrics.values['rpm'] > 17400 and electrics.values['rpm'] < 19000 then
       electrics.values['RPM_led4'] = 1 else electrics.values['RPM_led4'] = 0
    end
	
    if electrics.values['rpm'] > 17500 and electrics.values['rpm'] < 19000 then
       electrics.values['RPM_led5'] = 1 else electrics.values['RPM_led5'] = 0
    end
	
    if electrics.values['rpm'] > 17600 and electrics.values['rpm'] < 19000 then
       electrics.values['RPM_led6'] = 1 else electrics.values['RPM_led6'] = 0
    end
	
    if electrics.values['rpm'] > 17700 and electrics.values['rpm'] < 19000 then
       electrics.values['RPM_led7'] = 1 else electrics.values['RPM_led7'] = 0
    end
	
    if electrics.values['rpm'] > 17800 and electrics.values['rpm'] < 19000 then
       electrics.values['RPM_led8'] = 1 else electrics.values['RPM_led8'] = 0
    end
	
    if electrics.values['rpm'] > 17900 and electrics.values['rpm'] < 19000 then
       electrics.values['RPM_led9'] = 1 else electrics.values['RPM_led9'] = 0
    end
	
    if electrics.values['rpm'] > 18000 and electrics.values['rpm'] < 19000 then
       electrics.values['RPM_led10'] = 1 else electrics.values['RPM_led10'] = 0
    end
	
    if electrics.values['rpm'] > 18100 and electrics.values['rpm'] < 19000 then
       electrics.values['RPM_led11'] = 1 else electrics.values['RPM_led11'] = 0
    end
	
    if electrics.values['rpm'] > 18200 and electrics.values['rpm'] < 19000 then
       electrics.values['RPM_led12'] = 1 else electrics.values['RPM_led12'] = 0
    end
	
    if electrics.values['rpm'] > 18300 and electrics.values['rpm'] < 19000 then
       electrics.values['RPM_led13'] = 1 else electrics.values['RPM_led13'] = 0
    end
	
    if electrics.values['rpm'] > 18400 and electrics.values['rpm'] < 19000 then
       electrics.values['RPM_led14'] = 1 else electrics.values['RPM_led14'] = 0
    end
	
    if electrics.values['rpm'] > 18500 and electrics.values['rpm'] < 19000 then
       electrics.values['RPM_led15'] = 1 else electrics.values['RPM_led15'] = 0
    end
	
    if electrics.values['rpm'] < 3900 then
       electrics.values['RPM_ledoff'] = 1 else electrics.values['RPM_ledoff'] = 0
    end
	
    if electrics.values['throttle'] < 0.8 then
       electrics.values['light1'] = 1 else electrics.values['light1'] = 0
    end
    
    local vals = M.values
    generateBlinkPDTimer(dt)
			

    	electrics.values['led_off1'] = (electrics.values['RPM_ledoff']  * blinkPDPulseRight)
    	electrics.values['led_off2'] = (electrics.values['RPM_ledoff']  * blinkPDPulseLeft)
    	electrics.values['light'] = (electrics.values['light1']  * blinkPDPulseLeft)

end


-- public interface
M.onInit      = onInit
M.onReset     = reset
M.updateGFX = updateGFX

return M